package jd_cookie

import (
	"context"
	"kami/api/jd_cookie/v1"
	"kami/internal/errHandler"
	"kami/internal/service"

	"github.com/gogf/gf/v2/errors/gcode"
	"github.com/gogf/gf/v2/errors/gerror"
)

// BatchCreate 批量创建Cookie账户
func (c *ControllerV1) BatchCreate(ctx context.Context, req *v1.BatchCreateReq) (res *v1.BatchCreateRes, err error) {
	_, err = service.SysAuth().LoginOnlyIFrame(ctx)
	if err != nil {
		err = errHandler.WrapError(ctx, gcode.CodeNotAuthorized, err, "权限不足")
		return
	}

	successIds, failedItems, err := service.JdCookie().BatchCreateAccount(ctx, req.Cookies)
	if err != nil {
		return nil, gerror.WrapCode(gcode.CodeInternalError, err, "批量创建Cookie账户失败")
	}

	res = &v1.BatchCreateRes{
		SuccessIds:  successIds,
		FailedCount: len(failedItems),
		FailedItems: failedItems,
	}
	return
}
